<template>
  <div
    class="Backlog"
    :class="{ 'Backlog--active': active }"
    @dragenter="dragIn"
    @dragleave="dragOut"
    @dragover="dragIn"
    @drop="drop"
  >
    <h2 class="BacklogTitle">Ordres de fabrication non affectés</h2>
    <div class="BacklogWrapper">
      <BacklogOrder
        v-for="order of backlogOrders"
        :key="order.id"
        :order="order"
        :resolution="resolution"
      />
    </div>
  </div>
</template>

<script lang="ts">
import { defineComponent, ref } from 'vue'
import { backlogOrders, workshop } from '@/states'
import BacklogOrder from '@/views/partial/BacklogOrder.vue'

export default defineComponent({
  name: 'BacklogList',
  components: { BacklogOrder },
  props: {
    resolution: {
      type: Number,
      required: true,
    },
  },

  setup() {
    return {
      backlogOrders,
      active: ref(false),
    }
  },

  methods: {
    dragIn(e: DragEvent) {
      e.preventDefault()
      this.active = true
    },

    dragOut(e: DragEvent) {
      e.preventDefault()
      this.active = false
    },

    drop(e: DragEvent) {
      this.active = false

      // get the draggable element
      if (e.dataTransfer) {
        const id = e.dataTransfer.getData('orderId')
        const order = workshop.orders[id]
        if (order) {
          order.schedule = undefined
        }
      }
    },
  },
})
</script>

<style lang="scss" scoped>
@use '../../style/variables' as v;

.BacklogTitle {
  text-align: center;
}

.BacklogWrapper {
  display: flex;
  flex-direction: row;
  flex-wrap: wrap;
  max-width: 1024px;
  margin: auto;
  padding: v.$spacing/2;
}

.Backlog {
  background-color: var(--background-color);

  &--active {
    background-color: var(--backlog--active);
    color: white;
    transition: background-color linear 200ms;

    .BacklogWrapper {
      opacity: 50%;
      transition: opacity linear 200ms;
    }
  }
}
</style>
